#include "fbpng.bi"
#include "fbgfx.bi"
#include once "crt.bi"


#define RGBA_R( c ) ( CUInt( c ) Shr 16 And 255 )
#define RGBA_G( c ) ( CUInt( c ) Shr  8 And 255 )
#define RGBA_B( c ) ( CUInt( c )        And 255 )
#define RGBA_A( c ) ( CUInt( c ) Shr 24         )

Sub Usage () 
    Print "** USO **"
    Print "   sqijer in.png out.bin w h id"
    Print "w, h = dimmensions in CHARS"
    Print "id = an identifier for the code example: big_bird"
    Print "Image must be #000000 for PAPER and #WHATEVER for INK"
End Sub

Function getCol (myclroror as Integer) as Byte
    If RGBA_R (myclroror) = 0 And RGBA_G (myclroror) = 0 And RGBA_B (myclroror) = 0 Then
        Return 0
    End If
    Return 1
End Function

dim as any ptr img          ' will contain the image loaded from the PNG
dim as FB.Image ptr img2
dim as String filename1
dim as String filename2
dim as integer i, j, x, y, xx, yy, xxx, yyy,f,idx,idx2, force
dim as ubyte tscreen (16000), col, cbuff (32000), cbuff2 (64000),d,c,e
dim as string o, id
dim as ubyte img_width = 80, img_height = 200

If Len (Command (1)) = 0 Or Len (Command (2)) = 0 Then 
    Usage
    End
End If

force = 99

if len(command(3)) <> 0 and len (command(4)) <> 0 then
    img_width = val(command(3))
    img_height = val(command(4))
else
    img_width = 32
    img_height = 21
end if

if len (command(5)) <> 0 Then
    id = command(5)
else
    id = "GFX"
End If

' Primero cargo el archivo de imagen
screenres 640, 480, 32, , -1

filename1 = Command (1)
img = png_load ( filename1 )
filename2 = Command (2)

if img then
'
else
    puts "Failed to load"
    system
end if

f=freefile
Open filename2 for output as #f



print #f,id + "_pokevars:"
print #f,"            " + id + "_x: defb 0"
print #f,"            " + id + "_y: defb 0"
print #f,"            " + id + "_c: defb 7"
print #f,"" + id + "_code:"
print #f,"            ld      b, 0"
print #f,"            ld      hl, " + id + "_data"
print #f,"" + id + "_l1:"
print #f,"            push bc"
print #f,"            "
print #f,"            push hl"
print #f,"            ; get address"
print #f,"            ld      a, (" + id + "_y)  ;;"
print #f,"            add     a, b"
print #f,"            add     a, a"
print #f,"            ld      b, 0"
print #f,"            ld      c, a"
print #f,"            ld      hl, " + id + "_linebuff ;; "
print #f,"            add     hl, bc"
print #f,"            ld      e, (hl)"
print #f,"            inc     hl"
print #f,"            ld      d, (hl)"
print #f,"            ex      de, hl  "
print #f,"            ld      a, (" + id + "_x)  ;;"
print #f,"            ld      b, 0"
print #f,"            ld      c, a"
print #f,"            add     hl, bc"
print #f,"            ex      de, hl"
print #f,"            pop     hl"
print #f,"            "
print #f,"            ld      b, 8"
print #f,"" + id + "_l2:"
print #f,"            push    bc"
print #f,"            "
for i = 1 to img_width
	print #f,"            ldi"
next i
print #f,"            "
print #f,"            ; next line"
print #f,"            ld      bc, 256 - " + str (img_width)
print #f,"            ex      de, hl"
print #f,"            add     hl, bc"
print #f,"            ex      de, hl"
print #f,"            "
print #f,"            pop     bc"
print #f,"            djnz    " + id + "_l2  ;;"
print #f,"            "
print #f,"            pop     bc"
print #f,"            inc     b"
print #f,"            ld      a, b"
print #f,"            cp      " + str (img_height)
print #f,"            jr      nz," + id + "_l1  ;;"
print #f,""
print #f,"            ; add some colour"
print #f,"            ld      a, (" + id + "_y)"
print #f,"            ld      h, 0"
print #f,"            ld      l, a"
print #f,"            add     hl, hl      ; x2"
print #f,"            add     hl, hl      ; x4"
print #f,"            add     hl, hl      ; x8"
print #f,"            add     hl, hl      ; x16"
print #f,"            add     hl, hl      ; x32"
print #f,"            ld      a, (" + id + "_x)"
print #f,"            ld      d, 0"
print #f,"            ld      e, a"
print #f,"            add     hl, de      ; cool!"
print #f,"            ld      de, 22528"
print #f,"            add     hl, de"
print #f,"            "
print #f,"            ld      b, " + str (img_height)
print #f,"            ld      a, (" + id + "_c)"
print #f,"" + id + "_l3:         "
print #f,"            push    bc"
print #f,"            "
for i = 1 to img_width
	print #f,"            ld      (hl), a"
	if i < img_width then
		print #f,"            inc     hl"
	end if
next i
print #f,"            "
print #f,"            ; next line"
print #f,"            ld      bc, 33 - " + str (img_width)
print #f,"            add     hl, bc"
print #f,"            "
print #f,"            pop     bc"
print #f,"            djnz    " + id + "_l3"
print #f,"            "
print #f,"            ret"
print #f,"            "

Print #f,id + "_data:"
For yy = 0 To (8 * img_height) - 1 
    o = "            defb "
    For xx = 0 To (8 * img_width) - 1 Step 8
        c = 0
        For x = 0 to 7
            
            If getCol(point (x + xx, yy, img)) <> 0 Then
                c += 2^(7-x)
            End If
        Next x
        o = o + Str (c) + ", "
    Next xx
    o = left(o, len(o) - 2)
    print #f, o
Next yy

Print #f,id + "_linebuff:"
Print #f,"            defw $4000, $4020, $4040, $4060, $4080, $40A0, $40C0, $40E0"
Print #f,"            defw $4800, $4820, $4840, $4860, $4880, $48A0, $48C0, $48E0"
Print #f,"            defw $5000, $5020, $5040, $5060, $5080, $50A0, $50C0, $50E0"

puts "Todo correcto!"
close f
